#!/bin/bash
#SBATCH -A test                  # 自己所属的账户 (不要改)
#SBATCH -J fedavg               # 所运行的任务名称 (自己取)
#SBATCH -N 1                    # 占用的节点数（根据代码要求确定）
#SBATCH --ntasks-per-node=5     # 运行的进程数（根据代码要求确定）
#SBATCH --cpus-per-task=2       # 每个进程的CPU核数 （根据代码要求确定）
#SBATCH --gres=gpu:1            # 占用的GPU卡数 （根据代码要求确定）
#SBATCH -p p40                  # 任务运行所在的分区 (根据代码要求确定，gpu为gpu分区，gpu4为4卡gpu分区，cpu为cpu分区)
#SBATCH -t 0-48:00:00            # 运行的最长时间 day-hour:minute:second
#SBATCH -o fedavg.out        # 打印输出的文件
# 运行代码
#cd standalone/fedavg
#nohup python main_fedavg_ft.py --epochs 3 --tag test4 &
#nohup python main_ditto.py --epochs 3 --tag test3 &
#cd ../fedspa
#nohup python main_fedspa.py --dense_ratio 0.5  --epochs 3 --tag test3 --gradient_check  &
##nohup python main_fedspa.py --dense_ratio 0.5 --gpu 0 --epochs 3 --tag test3   &
#nohup python main_fedspa.py --dense_ratio 0.2  --epochs 3 --tag test3  --gradient_check  &
##nohup python main_fedspa.py --dense_ratio 0.2 --gpu 1 --epochs 3 -- test3   &
#nohup python main_fedspa.py --dense_ratio 0.1 --gpu 1 --epochs 3 --tag test3 --gradient_check &
##python main_fedspa.py --dense_ratio 0.1 --gpu 1 --epochs 3 --tag test3 --comm_round 2000
cd ../../../standalone/fedavg
wandb offline
nohup python main_fedavg.py  --dataset emnist --model lenet5 --partition_method homo --tag test10 --comm_round 400  >m1.out 2>&1  &
nohup python main_fedavg.py  --dataset emnist --model lenet5 --partition_method hetero --tag test10  --partition_alpha 0.2 --comm_round 400  >m2.out 2>&1 &
nohup python main_fedavg.py  --dataset emnist --model lenet5 --partition_method hetero --tag test10  --partition_alpha 0.1 --comm_round 400   >m3.out 2>&1 &
wait

#python main_fedspa.py --dense_ratio 0.1 --gpu 0 --epochs 3 --tag test5 --gradient_check --comm_round  1500
